`include "behavior.v"

module world(
		posx_disp, posy_disp, heading_disp,
		delta_heading, cat_headings, burst_state, type_out, caught,
		posx_in, posy_in, heading_in, burst_enabled, type_in
		);
		
	input [79:0]  posx_in, posy_in;
	input [31:0] heading_in, type_in;
	input [7:0] burst_enabled;
	
	output [79:0] posx_disp, posy_disp;
	output [31:0] heading_disp, delta_heading, type_out,cat_headings;
	output [7:0] burst_state;
	output caught;

	assign posx_disp = posx_in;				//pipe the inputs directly to the display outputs
	assign posy_disp = posy_in;
	assign heading_disp = heading_in;

	wire [7:0] catcher;	
	
	reg [2:0] animal_control_1,animal_control_2,
		  animal_control_3,animal_control_4,
		  animal_control_5,animal_control_6,
		  animal_control_7;
	reg [31:0] type_out_reg;
	reg caught_reg;
		  
	initial begin					//which cat are we controlling
		animal_control_1 = 1;
		animal_control_2 = 2;
		animal_control_3 = 3;
		animal_control_4 = 4;
		animal_control_5 = 5;
		animal_control_6 = 6;
		animal_control_7 = 7;
	end

	assign cat_headings[3:0] = 0;
	assign burst_state[0] = 0;
	assign catcher[0] = 0; 

	assign type_out = type_out_reg;

	assign caught = caught_reg;
							
	basic_alg b_alg1(						//determine the cats next position with basic_alg
			cat_headings[7:4],burst_state[1], catcher[1], animal_control_1,
			posx_in, posy_in, heading_in, burst_enabled
			);

	basic_alg b_alg2(						//determine the cats next position with basic_alg
			cat_headings[11:8],burst_state[2], catcher[2], animal_control_2,
			posx_in, posy_in, heading_in, burst_enabled
			);

	basic_alg b_alg3(						//determine the cats next position with basic_alg
			cat_headings[15:12],burst_state[3], catcher[3], animal_control_3,
			posx_in, posy_in, heading_in, burst_enabled
			);

	basic_alg b_alg4(						//determine the cats next position with basic_alg
			cat_headings[19:16],burst_state[4], catcher[4], animal_control_4,
			posx_in, posy_in, heading_in, burst_enabled
			);

	basic_alg b_alg5(						//determine the cats next position with basic_alg
			cat_headings[23:20],burst_state[5], catcher[5], animal_control_5,
			posx_in, posy_in, heading_in, burst_enabled
			);

	basic_alg b_alg6(						//determine the cats next position with basic_alg
			cat_headings[27:24],burst_state[6], catcher[6], animal_control_6,
			posx_in, posy_in, heading_in, burst_enabled
			);

	basic_alg b_alg7(						//determine the cats next position with basic_alg
			cat_headings[31:28],burst_state[7], catcher[7], animal_control_7,
			posx_in, posy_in, heading_in, burst_enabled
			);

	always @ (*) begin						//if a cat has caught the mouse, raise a flag
		if (catcher>0) begin
			type_out_reg[3:0] = 15;
			type_out_reg[31:4] = type_in[31:4];
			caught_reg = 1;
		end
		else begin
			type_out_reg = type_in;
			caught_reg = 0;
		end
	end

endmodule
