
module human_input(delta_heading, burst, left_button, right_button, burst_button, gameclock);
	input left_button, right_button, burst_button, gameclock;

	output burst;
	reg burst;

	output [3:0] delta_heading;
	reg [3:0] delta_heading;

	reg button_down;
	
	always @ (gameclock) begin

		delta_heading = 0;

		if (left_button & ~button_down) begin
			button_down = 1;
			delta_heading = 4'b0001;
		end

		if (right_button & ~button_down) begin
			button_down = 1;
			delta_heading = 4'b1111;
		end

		if (~right_button & ~left_button) button_down = 0;

		if (burst_button) burst = 1;
		else burst = 0;
	
	end
endmodule
