`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// William Dvorak, Leif Jentoft, Angela Sharer, and Lyndsey Stadtmueller	 
// Olin College of Engineering: Computer Architecture
// December 13, 2007
//////////////////////////////////////////////////////////////////////////////////
module fpga_top(vga_hsync, vga_vsync, vga_r, vga_g, vga_b, led0, led1, led2, led3, led4, led5, led6, led7, clk, button_left, button_burst, button_reset, button_right);
	output vga_hsync, vga_vsync, vga_r, vga_g, vga_b; 
	output led0, led1, led2, led3, led4, led5, led6, led7;
	input button_left, button_burst, button_reset, button_right, clk;

	// these go from game to animal
	reg [31:0] type_in;
	initial type_in = 0;

	// these go from animal to world
	wire [79:0] animal_posx, animal_posy;
	wire [31:0] animal_heading;
	wire [7:0] animal_burst_enabled;
	wire [31:0] animal_type;

	// these go from world to animal
	wire [31:0] delta_heading; 
	wire [7:0] 	delta_burst; 
	
	// these go from world to graphics
	wire [79:0] posx_disp, posy_disp;
	wire [31:0] heading_disp;
	wire [31:0] type_world;
	wire [7:0] caught;
	
	wire [3:0] mouse_heading;
	wire [31:0] cat_heading;
	reg [79:0] posx_disp_reg,posy_disp_reg;
	reg end_game;

	assign led0 = caught[0];
	assign led1 = caught[1];
	
	assign led4 = cat_heading[7];
	assign led5 = cat_heading[6];
	assign led6 = cat_heading[5];
	assign led7 = cat_heading[4];

	assign led2 = button_left;
	assign led3 = button_right;

	human_input User (mouse_heading, button_left, button_right, vga_vsync);

	animal Animal0  (animal_posx[9:0], animal_posy[9:0], animal_heading[3:0], animal_burst_enabled[0], animal_type[3:0], mouse_heading, 15, button_burst, type_in[3:0], 40, 30, vga_vsync);
	animal Animal1  (animal_posx[19:10], animal_posy[19:10], animal_heading[7:4], animal_burst_enabled[1], animal_type[7:4], delta_heading[7:4], cat_heading[7:4], delta_burst[1], type_in[7:4], 120, 90, vga_vsync);
	animal Animal2  (animal_posx[29:20], animal_posy[29:20], animal_heading[11:8], animal_burst_enabled[2], animal_type[11:8], delta_heading[11:8], cat_heading[11:8], delta_burst[2], type_in[11:8], 200, 150, vga_vsync);
	animal Animal3  (animal_posx[39:30], animal_posy[39:30], animal_heading[15:12], animal_burst_enabled[3], animal_type[15:12], delta_heading[15:12], cat_heading[15:12], delta_burst[3], type_in[15:12], 280, 210, vga_vsync);
	animal Animal4  (animal_posx[49:40], animal_posy[49:40], animal_heading[19:16], animal_burst_enabled[4], animal_type[19:16], delta_heading[19:16], cat_heading[19:16], delta_burst[4], type_in[19:16], 360, 270, vga_vsync);
	animal Animal5  (animal_posx[59:50], animal_posy[59:50], animal_heading[23:20], animal_burst_enabled[5], animal_type[23:20], delta_heading[23:20], cat_heading[23:20], delta_burst[5], type_in[23:20], 440, 330, vga_vsync);
	animal Animal6  (animal_posx[69:60], animal_posy[69:60], animal_heading[27:24], animal_burst_enabled[6], animal_type[27:24], delta_heading[27:24], cat_heading[27:24], delta_burst[6], type_in[27:24], 520, 390, vga_vsync);
	animal Animal7  (animal_posx[79:70], animal_posy[79:70], animal_heading[31:28], animal_burst_enabled[7], animal_type[31:28], delta_heading[31:28], cat_heading[31:28], delta_burst[7], type_in[31:28], 600, 450, vga_vsync);

	world WorldSubmodule (posx_disp, posy_disp, heading_disp, delta_heading, cat_heading, delta_burst, type_world, caught, 
		animal_posx, animal_posy, animal_heading, animal_burst_enabled, animal_type);

	graphics GraphicsSubmodule (vga_hsync, vga_vsync, vga_r, vga_g, vga_b, posx_disp_reg, posy_disp_reg, heading_disp, end_game, clk);
	
	initial begin
		end_game = 0;
	end
	
	always @ (*) begin 
		if (caught > 0) begin
			end_game = 1;
		end
		if (end_game) begin
			posx_disp_reg = posx_disp;
			posy_disp_reg = posy_disp;
			if (button_reset) begin
				end_game = 0;
			end
		end
	end 
endmodule
