
module game(vga_hsync, vga_vsync, vga_r, vga_g, vga_b, button_left, button_right, button_burst, fpga_clock, led1, led2);
	output vga_hsync, vga_vsync, vga_r, vga_g, vga_b, led1, led2;
	input button_left, button_right, button_burst, fpga_clock;
/*
	// these go from animal to world
	wire [79:0] animal_posx, animal_posy; // this goes from animals to world
	wire [31:0] animal_heading; // this goes from animals to world
	wire [7:0] 	animal_burst_enabled; // this goes from the animals to the world module
	wire [31:0] animal_type;
*/
	// these go from world to graphics
	wire [31:0] world_delta_heading; 
	wire [7:0] 	world_burst; 
	wire [79:0] world_posx, world_posy;
	wire [31:0] world_heading; 
	wire [31:0] world_type; 
	//wire caught;

	reg gameclock;
	//reg [31:0] type_in;

	// initalize animal types
	initial begin
		//type_in = 32'b10001000100010001000100010001000;		
		gameclock = 0;
	end
/*	
	assign animal_type = 0;
	assign animal_heading = 0;
	
	assign animal_posx[9:0] = 200;
	assign animal_posy[9:0] = 200;
	assign animal_posx[19:10] = 300;
	assign animal_posy[19:10] = 300;
	assign animal_posx[79:20] = 0;
	assign animal_posx[79:20] = 0;
*/
	assign world_type = 0;
	assign world_heading = 0;

	assign world_posx[9:0] = 200;
	assign world_posy[9:0] = 200;
	assign world_posx[19:10] = 300;
	assign world_posy[19:10] = 300;
	assign world_posx[79:20] = 0;
	assign world_posx[79:20] = 0;
///////////////////////////////////////////////

	reg led1, led2;

	always @(posedge fpga_clock) begin
		//if (world_posx[9:0] == 200) begin
		led1 = 1;
		//end else begin
		led2 = 1;
		//end
	end

	// instantiate the clock generation module
	//CLOCK_GEN CLOCK_GEN (fpga_clock, system_clock_buffered, pixel_clock, reset);

	// instantiate the video timing generator
	//SVGA_TIMING_GENERATION SVGA_TIMING_GENERATION (pixel_clock, reset, h_synch, v_synch, blank, pixel_count, line_count);
/*
	human_input Human (delta_heading, burst, button_left, button_right, button_burst);
*/
/*
	animal Animal0  (animal_posx[9:0], animal_posy[9:0], animal_heading[3:0], animal_burst_enabled[0], animal_type[3:0], world_delta_heading[3:0], world_burst[0], type_in[3:0], 0);
	animal Animal1  (animal_posx[19:10], animal_posy[19:10], animal_heading[7:4], animal_burst_enabled[1], animal_type[7:4], world_delta_heading[7:4], world_burst[1], type_in[7:4], 0);
	animal Animal2  (animal_posx[29:20], animal_posy[29:20], animal_heading[11:8], animal_burst_enabled[2], animal_type[11:8], world_delta_heading[11:8], world_burst[2], type_in[11:8], 0);
	animal Animal3  (animal_posx[39:30], animal_posy[39:30], animal_heading[15:12], animal_burst_enabled[3], animal_type[15:12], world_delta_heading[15:12], world_burst[3], type_in[15:12], 0);
	animal Animal4  (animal_posx[49:40], animal_posy[49:40], animal_heading[19:16], animal_burst_enabled[4], animal_type[19:16], world_delta_heading[19:16], world_burst[4], type_in[19:16], 0);
	animal Animal5  (animal_posx[59:50], animal_posy[59:50], animal_heading[23:20], animal_burst_enabled[5], animal_type[23:20], world_delta_heading[23:20], world_burst[5], type_in[23:20], 0);
	animal Animal6  (animal_posx[69:60], animal_posy[69:60], animal_heading[27:24], animal_burst_enabled[6], animal_type[27:24], world_delta_heading[27:24], world_burst[6], type_in[27:24], 0);
	animal Animal7  (animal_posx[79:70], animal_posy[79:70], animal_heading[31:28], animal_burst_enabled[7], animal_type[31:28], world_delta_heading[31:28], world_burst[7], type_in[31:28], 0);

	world World	(world_posx, world_posy, world_heading, world_delta_headings, world_burst, world_type, caught, animal_posx, animal_posy, animal_headings, animal_burst_enabled, type_in);
*/
	//graphics Graphics (vga_hsync, vga_vsync, vga_r, vga_g, vga_b, world_posx, world_posy, world_heading, world_type, gameclock, fpga_clock, led1, led2);
	graphics Graphics (vga_hsync, vga_vsync, vga_r, vga_g, vga_b, world_posx, world_posy, world_heading, world_type, gameclock, fpga_clock);

endmodule
